/*$Id: fkHttpHandlerFactory.cpp,v 1.9 2006/11/05 14:13:36 jwrobel Exp $*/
/* ***** BEGIN LICENSE BLOCK *****
 *  This file is part of Firekeeper.
 *
 *  Copyright (C) 2006 Jan Wrobel <wrobel@blues.ath.cx>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * ***** END LICENSE BLOCK ***** */

/* to make NS_IMPL_THREADSAFE_ISUPPORTS* work*/
#ifdef MOZILLA_STRICT_API
#undef MOZILLA_STRICT_API
#endif

#ifdef XPCOM_GLUE
#undef XPCOM_GLUE
#endif

#include "nsISupportsImpl.h"
#define MOZILLA_STRICT_API
#define XPCOM_GLUE

#include "fkHttpHandlerFactory.h"
#include "Error.h"


fkHttpHandlerFactory::fkHttpHandlerFactory(fkHttpHandler *handler)
{
	TRACE("constructor %08x", this);
	this->httpHandler = handler;
}

fkHttpHandlerFactory::~fkHttpHandlerFactory()
{
	TRACE("destructor %08x", this);
}

NS_IMPL_THREADSAFE_ISUPPORTS1(fkHttpHandlerFactory, nsIFactory)


NS_IMETHODIMP
fkHttpHandlerFactory::CreateInstance(nsISupports *aOuter, const nsIID & iid, void **result)
{
	TRACE("create instance called");
	
	if (!result)
		return NS_ERROR_INVALID_ARG;
	
	
	nsresult rv = httpHandler->QueryInterface(iid, result);
	//NS_ADDREF(httpHandler);
	if (NS_FAILED(rv)) {
		TRACE("error");
		*result = nsnull;
	}

	TRACE("returning %08x ", *result);
	return rv;
}


NS_IMETHODIMP
fkHttpHandlerFactory::LockFactory(PRBool lock)
{
	return NS_ERROR_NOT_IMPLEMENTED;
}

